import java.util.Scanner;

/** Solve a quadratic function give the three inputs a b c separated by a space.<br>
 *  <br>
 *  Written by Louie<br>
 *  October 2016<br>
 *  Version 1.0<br>
 *  Language: Java (Version Java 1.8.0_91)<br>
 *  <br>
 *  Input: 1 3 1<br>
 *	Expected output: Two real roots: -0.3819660112501051 and -2.618033988749895<br>
 *<br>
 *	Input: 1 2 1<br>
 *	Expected output: One real root: -1.0<br>
 *<br>
 *	Input: 1 2 3<br>
 *	Expected output: No real roots. 
 *  
 */

public class Assign4_1 {
	public static void main(String [] args){
		double [] x;
		double [] eqn = new double[3];
		Scanner input = new Scanner(System.in);
		
		System.out.print("Enter quadratic componets seperated by spaces: ");
		for(int i=0; i<3; i++){
			eqn[i] = input.nextDouble();
		}
		input.close();
		
		x = solveQuadratic(eqn);
		
		if(x.length == 0){
			System.out.println("No real roots.");
		}
		else if(x.length == 1){
			System.out.println("One real root: " + x[0]);
		}
		else{
			System.out.println("Two real roots: " + x[0] + " and " + x[1]);
		}
	}
	
/** Solves a quadratic function passed an array of integers, returns an array of length of number of roots
 * 	containing the roots themselves.<br>
 *  <br>
 *  Written by Louie<br>
 *  October 2016<br>
 *  Version 1.0<br>
 *  Language: Java (Version Java 1.8.0_91)<br>
 *  
 */	
	public static double[] solveQuadratic(double [] eqn){
		final double EPSILON=1E-14;
		double[] num;
		double a = eqn[0];
		double b = eqn[1];
		double c = eqn[2];
		double discriminate = (b*b)-(4*a*c);
				
		if(Math.abs(discriminate) < EPSILON){
			//one roots
			num = new double[1];
			num[0] = ((-1*b) + Math.sqrt(discriminate))/(2*a);
		}
		else if(0 > discriminate){
			//zero roots
			num = new double[0];
		}
		else{
			//two roots
			num = new double[2];
			num[0] = ((-1*b) + Math.sqrt(discriminate))/(2*a);
			num[1] = ((-1*b) - Math.sqrt(discriminate))/(2*a);
		}
		
		return num;
	}

}
